#TEMPLATE(SAIFile, 'SuRF''s Server Bases Auto Increment Template Set'),FAMILY('ABC')
#!
#!
#!
#EXTENSION(SAIFile, 'SuRF''s Server Bases Auto Increment Global Extension'),APPLICATION
 #PROMPT('Enable SAIFile?',CHECK),%EnableSAIFile,DEFAULT(%True),AT(2)
#!
#!
#!
#AT(%GlobalData),WHERE(%EnableSAIFile AND %SQLAnywhereFound())
AutoIncFile          FILE,DRIVER('SQLAnywhere'),NAME('dummy')
Record                 RECORD
IncFld                   LONG,NAME('dummy_col')
                       END
                     END

AutoIncFileManager   CLASS(FileManager)
FileOpen               BYTE
Init                   PROCEDURE(ErrorClass EC)
TryGetAutoIncValue     PROCEDURE(ANY),BYTE
                     END

Access:AutoIncFile   AutoIncFileManager
#ENDAT
#!
#!
#AT(%FileManagerCodeSection, , 'Open', '(),BYTE'),WHERE(%EnableSAIFile AND %SQLAnywhereFound()),PRIORITY(6000),DESCRIPTION('SAIFile')
  #IF(%SAIFileRequired())
SELF.HasServerAutoInc = TRUE
    #FOR(%Key)
      #IF(%KeyAuto)
SELF.AutoIncKey &= %Key
SELF.AutoIncField &= %KeyAuto
        #BREAK
      #ENDIF
    #ENDFOR
  #ENDIF
#ENDAT
#!
#!
#AT(%FileManagerCodeSection, , 'PrimeAutoInc', '(),BYTE'),WHERE(%EnableSAIFile AND %SQLAnywhereFound()),PRIORITY(3000),DESCRIPTION('SAIFile')
  #IF(%SAIFileRequired())
#INSERT(%SetNULLs)
  #ENDIF
#ENDAT
#!
#!
#AT(%FileManagerCodeSection, , 'TryGetAutoIncValue', '(),BYTE'),WHERE(%EnableSAIFile AND %SQLAnywhereFound()),PRIORITY(3000),DESCRIPTION('SAIFile')
  #IF(%SAIFileRequired())
Access:AutoIncFile.Init(SELF.Errors)
RETURN Access:AutoIncFile.TryGetAutoIncValue(SELF.AutoIncField)
  #ENDIF
#ENDAT
#!
#!
#AT(%FileManagerCodeSection, , 'TryPrimeAutoInc', '(),BYTE'),WHERE(%EnableSAIFile AND %SQLAnywhereFound()),PRIORITY(3000),DESCRIPTION('SAIFile')
  #IF(%SAIFileRequired())
#INSERT(%SetNULLs)
  #ENDIF
#ENDAT
#!
#!
#AT(%ProgramProcedures),WHERE(%EnableSAIFile AND %SQLAnywhereFound())


AutoIncFileManager.Init PROCEDURE(ErrorClass EC)
  CODE
    IF ~SELF.FileOpen
      PARENT.Init(AutoIncFile, EC)
      SELF.Buffer &= AutoIncFile.Record
      SELF.Create = 0
      SELF.LazyOpen = FALSE
      SELF.Open()
      SELF.FileOpen = TRUE
    END


AutoIncFileManager.TryGetAutoIncValue PROCEDURE(ANY AutoIncField)
  CODE
    SELF.File{PROP:SQL} = 'SELECT @@identity'
    IF ERRORCODE()
      SELF.SetError(Msg:AbortReading)
      RETURN Level:Notify
    END
    IF SELF.TryNext()
      RETURN Level:Notify
    END
    AutoIncField = AutoIncFile.IncFld
    RETURN Level:Benign
#ENDAT
#!
#!
#!
#!
#!
#GROUP(%SQLAnywhereFound),PRESERVE
#FOR(%File)
  #IF(UPPER(%FileDriver) = 'SQLANYWHERE')
    #RETURN(%True)
  #ENDIF
#ENDFOR
#RETURN(%False)
#!
#!
#GROUP(%SetNULLS)
  #FOR(%Key)
    #IF(%KeyAuto)
SETNULL(%KeyAuto)
      #BREAK
    #ENDIF
  #ENDFOR
#!
#!
#GROUP(%SAIFileRequired),PRESERVE
#IF(UPPER(%FileDriver) = 'SQLANYWHERE')
  #FOR(%Key)
    #IF(%KeyAuto AND INSTRING('SERVERAUTOINC', UPPER(%KeyUserOptions), 1, 1))
      #RETURN(%True)
    #ENDIF
  #ENDFOR
#ENDIF
#RETURN(%False)
